
//
//
// Project       : Vorpal-Mail
//
// Source        : hash.cc
//
// Creator       : Blane Bramble                    Date          : 26th October 2000
// Amended       : Blane Bramble                    Date          : 7th November 2000
//
// License       : Copyright Virtua-Web
//
// Support routines to create and manipulate a hashed list.
//

#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "list.h"
#include "hash.h"


//
// Private functions
//

long HASHTABLE::hash(char *s)
{
long n = 0;

while(*s != 0)			// usual nonsense hash function. Mathematically probably very flawed.
	{
	n <<= *s & 1;
	n += *s;
	n += (*(s+1) >> 2);
	s++;
	}

return n % tablesize;
}

//
// PUBLIC class functions
//

HASHTABLE::HASHTABLE(int n)
{
int i;
// table = (LIST **)malloc(n * sizeof(LISTITEM *));

tablesize = n;
table = new LIST *[n];		// create an array of pointers

for(i=0;i<n;i++)
//	*(table + i) = NULL;
	table[i] = NULL;
}

HASHTABLE::~HASHTABLE()
{
int i;
for(i=0;i<tablesize;i++)
//	if (*(table + i) != NULL)
//		delete *(table + i);
	if (table[i] != NULL)
		delete table[i];
}

LISTITEM *HASHTABLE::find(char *key)
{
int h;
h = hash(key);
if (table[h] == NULL)
	return NULL;
return table[h]->find(key);
}

LISTITEM *HASHTABLE::touchfind(char *key)
{
int h;
h = hash(key);
if (table[h] == NULL)
	return NULL;
return table[h]->touchfind(key);
}

void HASHTABLE::untouch(void)
{
int h;
for(h=0;h<tablesize;h++)
	{
	if (table[h] != NULL)
		table[h]->untouch();
	}
}

LISTITEM *HASHTABLE::add(char *key, void *data)
{
int h;
h = hash(key);
if (table[h] == NULL)
	table[h] = new LIST();
return table[h]->add(key, data);
}

LIST *HASHTABLE::get(int n)
{
return table[n % tablesize];
}

