
//
//
// Project       : Vorpal-Mail
//
// Source        : list.h
//
// Creator       : Blane Bramble                    Date          : 26th October 2000
// Amended       : Blane Bramble                    Date          : 27th October 2000
//
// License       : Copyright Virtua-Web
//
// Definitions for linked list class
//

#ifndef __LISTITEM__
#define __LISTITEM__

class LISTITEM {
	private:
		LISTITEM *prev, *next;
		char *key;
		void *data;
		int itouch;
	public:
		LISTITEM(char *, void *);
		~LISTITEM();
		char *getkey(void) { return key; };
		void *getdata(void) { return data; };
		LISTITEM *getnext(void) { return next; };
		LISTITEM *getprev(void) { return prev; };
		void setnext(LISTITEM *n) { next = n; };
		void setprev(LISTITEM *p) { prev = p; };
		void touch(void) { itouch = 1; };
		void untouch(void) { itouch = 0; };
		int touched(void) { return itouch; };
	};

class LIST {
	private:
		LISTITEM *head, *tail;
	public:
		LIST(void);
		~LIST();
		LISTITEM *add(char *, void *);
		LISTITEM *find(char *);
		LISTITEM *finddata(void *);
		LISTITEM *touchfind(char *);
		void untouch(void);
		LISTITEM *gethead(void) { return head; };
		void *del(LISTITEM *);
	};

#endif

